/*
 *
 * Copyright  :: 1995-1999 (C)opyright Gordano Ltd
 *               All rights reserved.
 *               No copies of this source may be made without express written
 *               permission of Gordano Ltd, PO Box 79, Clevedon,
 *               North Somerset, BS21 7TQ, UK
 *
 * $Header: d:\source\data\ntmail17_01\com\ntmcomtest/ntmcomtest.cpp,v 1.7 2003/03/10 10:23:23 garrardc Exp $
 *
 * $Log: ntmcomtest.cpp,v $
// Revision 1.7  2003/03/10  10:23:23  garrardc
// add uservar tests and correct email address
//
// Revision 1.6  2001/11/08  12:17:41  griffj
// Added logon.
//
// Revision 1.5  2000/09/03  18:21:53  garrardc
// COM Message API
//
// Revision 1.4  1999/11/10  20:24:18  garrardc
// add test code for DomainAdd
//
// Revision 1.3  1999/11/09  10:58:22  garrardc
// update to test both early and late binding methods
//
// Revision 1.2  1999/10/18  12:32:28  garrardc
// set log level
//
// Revision 1.1  1999/10/15  11:43:30  garrardc
// Initial revision
//
 * 
 */

#include <objbase.h>

#include "ntmcom.h"

#include <comdef.h>

BSTR psz2bstr( const char *str )
{
	return( _com_util::ConvertStringToBSTR( str ) ); // REALLY USEFUL -- comutil.h
}

int main( int argc, char *argv[] )
{
	HRESULT hr;
    BSTR logonuser = psz2bstr( "postmaster" );
    BSTR logondomain = psz2bstr( "nugold.co.uk" );
    BSTR logonpassword = psz2bstr( "password" );
	BSTR user = psz2bstr( "user" );
	BSTR domain = psz2bstr( "test.dom" );
	BSTR password = psz2bstr( "password" );
	int prevLevel = 0;
    BSTR newdomain = psz2bstr( "virt.dom" );
	BSTR basedomain = psz2bstr( "your.company.com" );
	BSTR postfix = psz2bstr( "virt.dom" );
	BSTR variable = psz2bstr( "Type" );

	BSTR destination = psz2bstr( "user@test.dom" );
	BSTR source = psz2bstr( "you@your.company.com" );
	BSTR subject = psz2bstr( "test com message object" );
	BSTR text = psz2bstr( "one line\r\n\r\na second line\r\n\r\nfinal line" );
	BSTR comClause = psz2bstr( "X-CustomHeader" );
	BSTR comClauseText = psz2bstr( "beta version" );
	BSTR ccClause = psz2bstr( "Cc" );
	BSTR ccClauseText = psz2bstr( "him@your.company.com; her@your.company.com" );
	BSTR filename = psz2bstr( "d:\\path\\to\\file.doc" );
	BSTR recipient1 = psz2bstr( "him@your.company.com" );
	BSTR recipient2 = psz2bstr( "her@your.company.com" );
    GClosureFlag closure_flag = GCloseSend;
    GMessageHandle handle;
    BSTR x;

	// early binding by default
	if ( argc == 1 )
	{
		IGordanoConfig *pIGordanoConfig = NULL;
		
		CoInitialize( NULL );
	
		hr = ::CoCreateInstance( CLSID_GordanoConfig, NULL, CLSCTX_INPROC_SERVER, IID_IGordanoConfig, (void **)&pIGordanoConfig );
		if ( SUCCEEDED( hr ) )
		{
			pIGordanoConfig->GLogLevel( 1, &prevLevel );
            x = psz2bstr( "" );
            hr = pIGordanoConfig->GUserGetVar(logonuser, logondomain, variable, &x );
			hr = pIGordanoConfig->GLogon( logonuser, logondomain, logonpassword );
            x = psz2bstr( "" );
            hr = pIGordanoConfig->GUserGetVar(logonuser, logondomain, variable, &x );
			hr = pIGordanoConfig->GUserAdd( user, domain, password, 1 );
			hr = pIGordanoConfig->GDomainAdd( newdomain, 8, basedomain, postfix );
			hr = pIGordanoConfig->GMessageOpen( destination, source, subject, &handle );
			hr = pIGordanoConfig->GMessageAppend( handle, text );
			hr = pIGordanoConfig->GMessageSetHeader( handle, comClause, comClauseText );
			hr = pIGordanoConfig->GMessageSetHeader( handle, ccClause, ccClauseText );
			hr = pIGordanoConfig->GMessageAttach( handle, filename );
			hr = pIGordanoConfig->GMessageAddRecipient( handle, recipient1 );
			hr = pIGordanoConfig->GMessageAddRecipient( handle, recipient2 );
			hr = pIGordanoConfig->GMessageClose( handle, closure_flag );
			pIGordanoConfig->Release();
		}
		
		CoUninitialize();
	}
	else
	{
		IDispatch *pID = NULL;
		DISPID dispid;
		DISPPARAMS dp = { NULL, NULL, 0, 0 };
		VARIANTARG varg[ 10 ];
		VARIANTARG result;
		unsigned int argError;
		OLECHAR *name = NULL;
        CLSID clsid;
		wchar_t progid [] = L"GordanoConfig.GordanoConfig";

		// late binding
		
		OleInitialize( NULL );

		::CLSIDFromProgID( progid, &clsid );
		
		hr = ::CoCreateInstance( clsid, NULL, CLSCTX_INPROC_SERVER, IID_IDispatch, (void **)&pID );
		if ( SUCCEEDED( hr ) )
		{
		    name = L"GLogLevel";
			pID->GetIDsOfNames( IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid );
			
			// arguments are in reverse order
			::VariantInit( &varg[ 1 ] );
			varg[ 1 ].vt = VT_INT;
			varg[ 1 ].intVal = 1;
			
			::VariantInit( &varg[ 0 ] );
			varg[ 0 ].vt = VT_BYREF | VT_INT;
			varg[ 0 ].pintVal = &prevLevel;
			
			dp.cArgs = 2;
			dp.rgvarg = varg;
			
			::VariantInit( &result );
			result.vt = VT_I4;
			result.lVal = 0;
			
			pID->Invoke( dispid, IID_NULL, GetUserDefaultLCID(), DISPATCH_METHOD, &dp, &result, NULL, &argError );
			hr = result.lVal;
		}
		if ( SUCCEEDED( hr ) )
		{
			name = L"GUserAdd";
			pID->GetIDsOfNames( IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid );
			
			// arguments are in reverse order
			::VariantInit( &varg[ 3 ] );
			varg[ 3 ].vt = VT_BSTR;
			varg[ 3 ].bstrVal = user;
			
			::VariantInit( &varg[ 2 ] );
			varg[ 2 ].vt = VT_BSTR;
			varg[ 2 ].bstrVal = domain;
			
			::VariantInit( &varg[ 1 ] );
			varg[ 1 ].vt = VT_BSTR;
			varg[ 1 ].bstrVal = password;
			
			::VariantInit( &varg[ 0 ] );
			varg[ 0 ].vt = VT_INT;
			varg[ 0 ].intVal = 1;
			
			dp.cArgs = 4;
			dp.rgvarg = varg;
			
			::VariantInit( &result );
			result.vt = VT_I4;
			result.lVal = 0;
			
			pID->Invoke( dispid, IID_NULL, GetUserDefaultLCID(), DISPATCH_METHOD, &dp, &result, NULL, &argError );
			hr = result.lVal;
		}
		if ( SUCCEEDED( hr ) )
		{
			name = L"GDomainAdd";
			pID->GetIDsOfNames( IID_NULL, &name, 1, GetUserDefaultLCID(), &dispid );
			
			// arguments are in reverse order
			::VariantInit( &varg[ 3 ] );
			varg[ 3 ].vt = VT_BSTR;
			varg[ 3 ].bstrVal = newdomain;
			
			::VariantInit( &varg[ 2 ] );
			varg[ 2 ].vt = VT_INT;
			varg[ 2 ].intVal = 8;
			
			::VariantInit( &varg[ 1 ] );
			varg[ 1 ].vt = VT_BSTR;
			varg[ 1 ].bstrVal = basedomain;
			
			::VariantInit( &varg[ 0 ] );
			varg[ 0 ].vt = VT_BSTR;
			varg[ 0 ].bstrVal = postfix;
			
			dp.cArgs = 4;
			dp.rgvarg = varg;
			
			::VariantInit( &result );
			result.vt = VT_I4;
			result.lVal = 0;
			
			pID->Invoke( dispid, IID_NULL, GetUserDefaultLCID(), DISPATCH_METHOD, &dp, &result, NULL, &argError );
			hr = result.lVal;
		}
	}

	return( 0 );
}