/*
 *
 * Copyright  :: 1995-1999 (C)opyright Gordano Ltd
 *               All rights reserved.
 *               No copies of this source may be made without express written
 *               permission of Gordano Ltd, PO Box 79, Clevedon,
 *               North Somerset, BS21 7TQ, UK
 *
 * $Header: d:\source\data\ntmail17_01\optpack\smtpdll/smtp_dll_type.h,v 1.3 2004/02/04 09:58:32 garrardc Exp $
 *
 * $Log: smtp_dll_type.h,v $
 * Revision 1.3  2004/02/04  09:58:32  garrardc
 * OR 07006 - no autoresponse via mailman if virtual
 *
 * Revision 1.2  1999/09/15  17:05:15  garrardc
 * removed unused #includes
 *
 * Revision 1.1  1999/09/15  16:59:33  garrardc
 * Initial revision
 *
 * 
 */

#ifndef _SMTP_DLL_TYPE_H
#define _SMTP_DLL_TYPE_H

#include <windows.h>

#include "constant.h"

#ifdef __cplusplus
extern "C" {
#endif

#define MAX_SMTP_DESCRIPTION    1024

typedef void *SMTP_HANDLE;

typedef struct smtp_version_struct
{
    DWORD version;
    SMTP_HANDLE context;
    char description[ MAX_SMTP_DESCRIPTION ];
    char copyright[ MAX_SMTP_DESCRIPTION ];
} SMTP_VERSION;

typedef enum
{
    SMTP_STATUS_STAT        = 1,
    SMTP_STATUS_FAILURE     = 2,
    SMTP_STATUS_DEBUG       = 4,
    SMTP_STATUS_PROGRESS    = 8
} SMTP_STATUS;

typedef enum
{
    SMTP_DLL_SUCCESS    = 0,
    SMTP_DLL_PROCESSED  = 1,
    SMTP_DLL_REJECT     = 2
} SMTP_RETURN;

typedef struct smtp_info_struct
{
    DWORD size;
    DWORD version;
    SMTP_HANDLE context;
    int depth;
    int ESMTPError;
    struct in_addr ClientIPAddress;
    char Client[ MAX_EMAIL_ADDRESS ];
    struct in_addr ServerIPAddress;
    char Server[ MAX_EMAIL_ADDRESS ];
    char ESMTPOptions[ MAX_ESMTP_LEN ];
    char Filename[ MAX_FILENAME ];
    char From[ MAX_EMAIL_ADDRESS ];
    char Rcpt[ MAX_EMAIL_ADDRESS ];
    char AllRcpts[ MAX_STRING ];
    char Response[ MAX_PROTOCOL_MES_LEN ];
    char Mailbox[MAX_MAILBOX_NAME];
    char *Msg;
} SMTP_INFO;

typedef enum
{
    SMTP_CONFIG_ACTION_NEW_USER     = 1,
    SMTP_CONFIG_ACTION_EDIT_USER    = 2,
    SMTP_CONFIG_ACTION_DELETE_USER  = 4,
    SMTP_CONFIG_ACTION_INSTALL      = 8,
    SMTP_CONFIG_ACTION_UNINSTALL    = 16
} SMTP_CONFIG_ACTION;

typedef struct smtp_config_struct
{
    DWORD size;
    DWORD version;
    SMTP_CONFIG_ACTION action;
    SMTP_HANDLE context;
    char user[ MAX_EMAIL_ADDRESS ];
    char domain[ MAX_EMAIL_ADDRESS ];
} SMTP_CONFIG;

typedef int (FAR PASCAL *LPFN_GET_SMTP_EXTENSION_VERSION)
(
    SMTP_VERSION *data
);

typedef int (FAR PASCAL *LPFN_CONFIGURE_SMTP_EXTENSION)
(
    SMTP_CONFIG *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPCONNECTION)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPEHLO)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPHELO)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPMAIL)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPRCPT)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPDATABEFORE)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPDATAAFTER)
(
    int id, SMTP_INFO *data
);

typedef SMTP_RETURN (FAR PASCAL *LPFN_SMTPDATAAFTEREACHRCPT)
(
    int id, SMTP_INFO *data
);

typedef struct _smtp_dll_info_struct
{
    HINSTANCE hDLL;
    SMTP_HANDLE context;
    LPFN_GET_SMTP_EXTENSION_VERSION getSmtpExtensionVersion;
    LPFN_CONFIGURE_SMTP_EXTENSION configureSmtpExtension;
    LPFN_SMTPCONNECTION smtpConnection;
    LPFN_SMTPEHLO smtpEhlo;
    LPFN_SMTPHELO smtpHelo;
    LPFN_SMTPMAIL smtpMail;
    LPFN_SMTPRCPT smtpRcpt;
    LPFN_SMTPDATABEFORE smtpDataBefore;
    LPFN_SMTPDATAAFTER smtpDataAfter;
    LPFN_SMTPDATAAFTEREACHRCPT smtpDataAfterEachRcpt;
} SMTP_DLL_INFO;  

#define SMTPDLLVersion (((VER_MAJOR*100)+VER_MINOR)*10000+VER_TRIVIAL)

#ifdef __cplusplus
}
#endif

#endif
