// Name: Break
// Description: Prompts people to take breaks
// AccessRights: ALL
// Type: ADMIN

var breakSelf;

function breakCheckTime()
{
    ok = confirm("Have you taken a break recently?\n\nClick OK to confirm you have taken your statutory break.");

    if (!ok)
    {
        ok = confirm("Please take a break.\n\nClick OK to confirm you have just taken your statutory break.");
    }

    var now = new Date();
    var timeout;
    var account = breakSelf.getAccountName();

    if (ok)
    {
        breakSelf.setConfigurationValue("lastBreak", now);

        timeout = breakSelf.breakPeriod;

        breakSelf.log(account + " has confirmed taking a break at " + now);
    }
    else
    {
        timeout = 1;

        breakSelf.log(account + " has not taken break.");
    }

    setTimeout(breakCheckTime, timeout  * 1000);
}

function breakStartCheckTime()
{
    var timeout = breakSelf.breakPeriod;

    var lastBreak = breakSelf.getConfigurationValue("lastBreak", "");

    if (lastBreak != "")
    {
        lastBreak = new Date(lastBreak);
        var now = new Date();

        var lastBreakDay = new Date(lastBreak.getFullYear(), lastBreak.getMonth(), lastBreak.getDate(), 0, 0, 0);
        var nowDay = new Date(now.getFullYear(), now.getMonth(), now.getDate(), 0, 0, 0);

        if (lastBreakDay.valueOf() == nowDay.valueOf())
        {
            var diff = (now - lastBreak) / 1000;

            timeout = timeout - diff;

            if (timeout < 1)
            {
                timeout = 1;
            }
        }
    }

    setTimeout(breakCheckTime, timeout * 1000);
}

function gmsPlugin_break()
{
    breakSelf = this;
}

gmsPlugin_break.prototype.init = function()
{
    this.breakPeriod = this.getConfigurationValue("breakPeriod", 3 * 60 * 60);

    setTimeout(breakStartCheckTime, 1000);
}


