// Name: Compose
// Description: Hides compose features
// AccessRights: ALL

var composeSelf;

function gmsPlugin_compose()
{
    composeSelf = this;

    composeSelf.level = -1;
}

gmsPlugin_compose.prototype.handleemail = function() { return true; };

function composeHideNode(id, attachments)
{
    var w = composeSelf.getCurrentWindow();

    var ele = w.document.getElementById(id);

    if (ele)
    {
        if (attachments)
        {
            ele = ele.parentNode.parentNode;
        }
        else
        {
            ele = ele.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
        }

        if (ele)
        {
            ele.style.display = "none";
        }
    }
}

function composeShowNode(id, attachments)
{
    var w = composeSelf.getCurrentWindow();

    var ele = w.document.getElementById(id);

    if (ele)
    {
        if (attachments)
        {
            ele = ele.parentNode.parentNode;
        }
        else
        {
            ele = ele.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
        }

        if (ele)
        {
            ele.style.display = "";
        }
    }
}

function saveConfiguration()
{
    composeSelf.setConfigurationValue("level", composeSelf.level);
}

function handleComposeClick(action)
{
    var w = composeSelf.getCurrentWindow();
    var level = composeSelf.level;
    var showEnabled = true;
    var hideEnabled = true;

    if (action == "hide")
    {
        level++;
    }
    else if (action == "show")
    {
        level--;
    }

    if (level > 3)
    {
        level = 3;
    }
    else if (level < 0)
    {
        level = 0;
    }

    if (level == 0)
    {
        composeShowNode("cc", false);
        composeShowNode("bcc", false);
        composeShowNode("attachmentsmenu", true);
        composeShowNode("include_my_vcard", true);

        showEnabled = false;
    }
    else if (level == 1)
    {
        composeShowNode("cc", false);
        composeHideNode("bcc", false);
        composeShowNode("attachmentsmenu", true);
        composeShowNode("include_my_vcard", true);
    }
    else if (level == 2)
    {
        composeShowNode("cc", false);
        composeHideNode("bcc", false);
        composeHideNode("attachmentsmenu", true);
        composeHideNode("include_my_vcard", true);
    }
    else
    {
        composeHideNode("cc");
        composeHideNode("bcc");
        composeHideNode("attachmentsmenu", true);
        composeHideNode("include_my_vcard", true);

        hideEnabled = false;
    }

    if (w.onresize)
    {
        w.onresize();
    }
    else if (w.document.body.onresize)
    {
        var fn = w.document.body.onresize;

        fn.call(w);
    }

    if (showEnabled)
    {
        composeSelf.enableMenuCommand("show", "context", w);
    }
    else
    {
        composeSelf.disableMenuCommand("show", "context", w);
    }

    if (hideEnabled)
    {
        composeSelf.enableMenuCommand("hide", "context", w);
    }
    else
    {
        composeSelf.disableMenuCommand("hide", "context", w);
    }

    composeSelf.level = level;

    setTimeout("saveConfiguration()", 250);
}

gmsPlugin_compose.prototype.init = function()
{
    this.level = this.getConfigurationValue("level", 0);
}

gmsPlugin_compose.prototype.windowload = function()
{
    var w = this.getCurrentWindow();

    this.registerMenuCommand("", "", "", "plus.png", "show", true, handleComposeClick, "context", w);
    this.registerMenuCommand("", "", "", "minus.png", "hide", true, handleComposeClick, "context", w);

    handleComposeClick("");
}
