// Name: Compose 2
// Description: Hides Compose features using jQuery
// AccessRights: ALL

var compose2Self;

function gmsPlugin_compose2()
{
    compose2Self = this;

    compose2Self.level = -1;
}

gmsPlugin_compose2.prototype.handleemail = function() { return true; };

function compose2HideNode(id, attachments)
{
    var w = compose2Self.getCurrentWindow();

    if (attachments)
    {
        $(id, w.document).parent().parent().hide();
    }
    else
    {
        $(id, w.document).parent().parent().parent().parent().parent().parent().hide();
    }
}

function compose2ShowNode(id, attachments)
{
    var w = compose2Self.getCurrentWindow();

    if (attachments)
    {
        $(id, w.document).parent().parent().show();
    }
    else
    {
        $(id, w.document).parent().parent().parent().parent().parent().parent().show();
    }
}

function saveConfiguration()
{
    compose2Self.setConfigurationValue("level", compose2Self.level);
}

function handleComposeClick(action)
{
    var w = compose2Self.getCurrentWindow();
    var level = compose2Self.level;
    var showEnabled = true;
    var hideEnabled = true;

    if (action == "hide")
    {
        level++;
    }
    else if (action == "show")
    {
        level--;
    }

    if (level > 3)
    {
        level = 3;
    }
    else if (level < 0)
    {
        level = 0;
    }

    if (level == 0)
    {
        compose2ShowNode("#cc,#bcc,", false);
        compose2ShowNode("#attachmentsmenu,#include_my_vcard", true);

        showEnabled = false;
    }
    else if (level == 1)
    {
        compose2ShowNode("#cc", false);
        compose2HideNode("#bcc", false);

        compose2ShowNode("#attachmentsmenu,#include_my_vcard", true);
    }
    else if (level == 2)
    {
        compose2ShowNode("#cc", false);
        compose2HideNode("#bcc", false);
        compose2HideNode("#attachmentsmenu,#include_my_vcard", true);
    }
    else
    {
        compose2HideNode("#cc,#bcc");
        compose2HideNode("#attachmentsmenu,#include_my_vcard", true);

        hideEnabled = false;
    }

    if (w.onresize)
    {
        w.onresize();
    }
    else if (w.document.body.onresize)
    {
        var fn = w.document.body.onresize;

        fn.call(w);
    }

    if (showEnabled)
    {
        compose2Self.enableMenuCommand("show", "context", w);
    }
    else
    {
        compose2Self.disableMenuCommand("show", "context", w);
    }

    if (hideEnabled)
    {
        compose2Self.enableMenuCommand("hide", "context", w);
    }
    else
    {
        compose2Self.disableMenuCommand("hide", "context", w);
    }

    compose2Self.level = level;

    setTimeout("saveConfiguration()", 250);
}

gmsPlugin_compose2.prototype.init = function()
{
    this.level = this.getConfigurationValue("level", 0);
}

gmsPlugin_compose2.prototype.windowload = function()
{
    var w = this.getCurrentWindow();

    this.registerMenuCommand("", "", "", "plus.png", "show", true, handleComposeClick, "context", w);
    this.registerMenuCommand("", "", "", "minus.png", "hide", true, handleComposeClick, "context", w);

    handleComposeClick("");
}
