// Name: Compose Quiz
// Description: User must answer some questions to send a message
// AccessRights: ALL
// ConfigurationRequired: Yes

var composequizSelf;

function gmsPlugin_composequiz()
{
    composequizSelf = this;
}

gmsPlugin_composequiz.prototype.handleemail = function() { return true; };

function composequizActive()
{
    var active = false;

    var from = composequizSelf.getConfigurationValue("from", "19:00");
    var to = composequizSelf.getConfigurationValue("to", "08:00");
    var days = composequizSelf.getConfigurationValue("days", "12345");

    var now = new Date();

    if (days.indexOf(now.getDay()) != -1)
    {
        var hours = now.getHours();
        var minutes = now.getMinutes();

        var str = "";

        if (hours < 10)
        {
            str += "0";
        }

        str += hours + ":";

        if (minutes < 10)
        {
            str += "0";
        }

        str += minutes;

        if (from < to)
        {
            if (str >= from && str <= to)
            {
                active = true;
            }
        }
        else
        {
            if (str >= from || str <= to)
            {
                active = true;
            }
        }
    }

    return active;
}

function docomposequizResult(action)
{
    var w = composequizSelf.getCurrentWindow();
    var e = w.document.getElementById("quiz");

    e.style.visibility="hidden";
    e.style.display="block";

    composequizSelf.clickMenuCommand(action, "context", w);
}

function docomposequizCounter(end)
{
    var w = composequizSelf.getCurrentWindow();

    if (!w.closed)
    {
        try
        {
            var now = new Date();

            end = new Date(end);

            var diff = end.getTime() - now.getTime();

            diff = parseInt((diff + 999) / 1000);

            var counter = w.document.getElementById("counter");

            counter.innerHTML = "<font size=6>" + diff + "</font>";

            var result;
            var answer;
            var tick;
            var correct = 0;
            var image;

            for (var i = 0;  i < 5; i++)
            {
                result = w.document.getElementById("result" + i).value;
                answer = w.document.getElementById("answer" + i).value;
                tick = w.document.getElementById("tick" + i);

                if (answer == result)
                {
                    correct ++;

                    image = "accept";
                }
                else
                {
                    image = "decline";
                }

                tick.innerHTML = "<img src='/themes/webmail/i/" + image + ".png'>";
            }

            var action = "";
            var message = "";
            var color;
            var delay;

            if (correct == 5)
            {
                action = "send";
                message = "You have passed the test - sending the message ....";
                color = "blue";
                delay = 1000;

                composequizSelf.registerMenuCommand("Send", "Ctrl+Enter", "Send", "send.png", "send", true, null, "context", w);
            }
            else if (diff != 0)
            {
                setTimeout("docomposequizCounter('" + end + "')", 100);
            }
            else
            {
                action = "save";
                message = "You have failed the test - the message will be saved to your Drafts folder ....";
                color = "red";
                delay = 5000;
            }

            if (message != "")
            {
                counter.innerHTML = "<font size=4 color=" + color + ">" + message + "</font>";
            }

            if (action != "")
            {
                setTimeout("docomposequizResult('" + action + "')", delay);
            }
        }
        catch(e)
        {
            // Window probably closed
        }
    }
}

function handlecomposequizClick(action)
{
    var ok = false;
    var w = composequizSelf.getCurrentWindow();
    var clientWidth = w.document.body.clientWidth;
    var clientHeight = w.document.body.clientHeight;
    var limit = parseInt(composequizSelf.getConfigurationValue("limit", "60"));
    var difficulty = composequizSelf.getConfigurationValue("difficulty", "Normal");

    var max;

    if (difficulty == "Easy")
    {
        max = 20;
    }
    else if (difficulty == "Hard")
    {
        max = 1000;
    }
    else
    {
        max = 100;
    }

    composequizSelf.disableMenuCommand("send", "context", w);

    var layer = w.document.createElement('DIV');

    layer.style.position = 'absolute';
    layer.style.left = clientWidth * 1/ 10 / 2 + 'px';
    layer.style.top = clientHeight * 1/ 10 / 2 + 'px';
    layer.style.border = "1px solid";
    layer.style.backgroundColor = 'white';

    layer.style.width = clientWidth * 9 /10 + 'px';
    layer.style.height = clientHeight * 9 /10 + 'px'

    var html = "";

    html += "<div id='quizdiv'><br><center><table>";
    html += "<tr align=center><td colspan=7>Please answer the following questions to send your email</td></tr>";
    html += "<tr><td colspan=6>&nbsp</td><td rowspan=7 valign=center align=center><span id='counter'><font size=6>" + limit + "</font></span></td></tr>";

    for (var i = 0;  i < 5; i++)
    {
        var randomnumber1 = Math.floor(Math.random() * max + 1)
        var randomnumber2 = Math.floor(Math.random() * max + 1)
        var result;
        var operator;

        if (Math.random() < 0.5)
        {
            result = randomnumber1 + randomnumber2;
            operator = "+";
        }
        else
        {
            result = randomnumber1 - randomnumber2;
            operator = "-";
        }

        html += "<tr><td align=right width=1%>&nbsp;&nbsp;&nbsp;" + randomnumber1 + "</td><td align=right width=1%>" + operator + "</td><td align=right width=1%>" + randomnumber2 + "</td><td width=1%>=</td><td align=right width=1%><input id='result" + i + "' size=3 value=''><input type= hidden id='answer" + i + "'  value='" + result + "'></td><td width=1%><span id='tick" + i + "'></span></tr>";
    }


    html += "<tr><td colspan=6>&nbsp</td></tr></div>";

    html += "</table>";

    layer.id = "quiz";
    layer.innerHTML = html;

    w.document.body.appendChild(layer);

    var e = w.document.getElementById("quizdiv");

    layer.style.height = e.clientHeight + "px";

    var end = new Date();

    end.setSeconds(end.getSeconds() + limit);

    docomposequizCounter(end);
}

gmsPlugin_composequiz.prototype.windowload = function()
{
    if (composequizActive())
    {
        var w = composequizSelf.getCurrentWindow();

        this.registerMenuCommand("Send", "Ctrl+Enter", "Send", "send.png", "send", true, handlecomposequizClick, "context", w);
    }
}

gmsPlugin_composequiz.prototype.previewload = function()
{
    if (composequizActive())
    {
        this.disableMenuCommand("send", "context");
    }
}

function composequizcorrecttime(str)
{
    var newStr = "";

    var index = str.indexOf(":");

    var hours = 0;
    var minutes = 0;

    if (index == -1)
    {
        var len = str.length;

        if (len == 4)
        {
            hours = Number(str.substring(0,2));
            minutes = Number(str.substring(2));
        }
        else if (len == 3)
        {
            hours = Number(str.substring(0,1));
            minutes = Number(str.substring(1));
        }
        else if (len == 2)
        {
            hours = Number(str.substring(0,2));
            minutes = 0;
        }
        else if (len == 1)
        {
            hours = Number(str.substring(0,1));
            minutes = 0;
        }
        else
        {
            hours = 0;
            minutes = 0;
        }
    }
    else
    {
        var fields = str.split(":");

        if (isNaN(fields[0]) || isNaN(fields[1]))
        {
            hours = 0;
            minutes = 0;
        }
        else
        {
            hours = Number(fields[0]);
            minutes = Number(fields[1]);
        }
    }

    if (hours > 23)
    {
        hours = 23;
    }

    if (minutes > 59)
    {
        minutes = 59;
    }

    if (hours < 10)
    {
        newStr += "0";
    }

    newStr += hours;

    newStr += ":";

    if (minutes < 10)
    {
        newStr += "0";
    }

    newStr += minutes;

    return newStr;
}

function composequizConfigButtonHandler()
{
    var w = composequizSelf.getContentWindow();

    var from = composequizSelf.getFieldValue("from");
    var to = composequizSelf.getFieldValue("to");
    var limit = composequizSelf.getFieldValue("limit");
    var days = "";
    var difficulty = "";
    var e;

    from = composequizcorrecttime(from);
    to = composequizcorrecttime(to);

    for (var i = 0; i < 7; i++)
    {
        e = w.document.getElementById("day" + i);

        if (e.checked)
        {
            days += i;
        }
    }

    e = w.document.getElementById("difficulty");

    if (e)
    {
        var index = e.selectedIndex;

        difficulty = e.options[index].value;
    }

    composequizSelf.setConfigurationValue("from", from);
    composequizSelf.setConfigurationValue("to", to);
    composequizSelf.setConfigurationValue("limit", limit);
    composequizSelf.setConfigurationValue("days", days);
    composequizSelf.setConfigurationValue("difficulty", difficulty);

    composequizSelf.configload();
}

gmsPlugin_composequiz.prototype.configload = function()
{
    var w = this.getContentWindow();

    var html = "";

    html += "<table>";
    html += "<tr><td >";
    html += "<input type=checkbox id=\"day0\">&nbsp;Sunday ";
    html += "<input type=checkbox id=\"day1\">&nbsp;Monday ";
    html += "<input type=checkbox id=\"day2\">&nbsp;Tuesday ";
    html += "<input type=checkbox id=\"day3\">&nbsp;Wednesday ";
    html += "<input type=checkbox id=\"day4\">&nbsp;Thursday ";
    html += "<input type=checkbox id=\"day5\">&nbsp;Friday ";
    html += "<input type=checkbox id=\"day6\">&nbsp;Saturday ";
    html += "</td></tr>";
    html += "</table>";
    html += "<table>";
    html += "<tr><td colspan=2>&nbsp;</td></tr>";
    html += "<tr><td>Start time</td><td><input id=\"from\" size=6></td></tr>";
    html += "<tr><td>End time</td><td><input id=\"to\" size=6></td></tr>";
    html += "<tr><td>&nbsp;</td></tr>";
    html += "<tr><td>Difficulty</td><td><select id=\"difficulty\"><option>Easy<option>Normal<option>Hard</select></td></tr>";
    html += "<tr><td>Time limit</td><td><input id=\"limit\" size=6></td></tr>";
    html += "<tr><td colspan=2>&nbsp;</td></tr>";
    html += "</table>";
    html += "<table width=100%>";
    html += "<tr><td align=right><span id=\"button1\"></span></td></tr>";
    html += "</table>";

    this.insertCustomContent("config", html);

    this.insertCustomButton("button1", "     OK     ", "ok", composequizConfigButtonHandler);

    var from = this.getConfigurationValue("from", "19:00");
    var to = this.getConfigurationValue("to", "08:00");
    var days = this.getConfigurationValue("days", "12345");
    var limit = this.getConfigurationValue("limit", "60");
    var difficulty = this.getConfigurationValue("difficulty", "Normal");

    this.setFieldValue("from", from);
    this.setFieldValue("to", to);
    this.setFieldValue("limit", limit);

    var e;

    for (var i = 0; i < 7; i++)
    {
        if (days.indexOf(i) != -1)
        {
            e = w.document.getElementById("day" + i);

            if (e)
            {
                e.checked = true;
            }
        }
    }

    e = w.document.getElementById("difficulty");

    if (e)
    {
        for (var i = 0; i < e.options.length; i++)
        {
            if (e.options[i].value == difficulty)
            {
                e.selectedIndex = i;
            }
        }
    }
}
