// Name: Dictionary
// Description: Multilingual word lookup
// AccessRights: ALL

var dictionarySelf;

function gmsPlugin_dictionary()
{
    dictionarySelf = this;
}

gmsPlugin_dictionary.prototype.handleemail = function() { return true; };
gmsPlugin_dictionary.prototype.handleaddressbook = function() { return true; };
gmsPlugin_dictionary.prototype.handlecalendar = function() { return true; };
gmsPlugin_dictionary.prototype.handletasks = function() { return true; };
gmsPlugin_dictionary.prototype.handlenotes = function() { return true; };

function lookupCallback(details)
{
    var text = details.responseText;

    var index = text.indexOf("<div id=\"results-col\"");
    text = text.slice(index);

    index = text.indexOf(">");
    text = text.slice(index + 1);

    index = text.indexOf("class=\"pos-style\"");
    text = text.slice(index);

    index = text.indexOf(">");
    text = text.slice(index + 1);

    index = text.indexOf("<div id=\"logo-div\"");
    text = text.slice(0, index);

    text = text.replace(/(<([^>]+)>)/ig,"");
    text = text.replace(/(&([^;]+);)/ig,"");

    if (text == "")
    {
        text = "No match found";
    }
    else
    {
        text = "Lookup: \"" + dictionarySelf.lookupText + "\":\r\n\r\n" + text;
    }

    alert(text);
}

function lookupDictionary(text, language)
{
    text = trim(text, " ");

    index = text.indexOf(" ");

    if (index == -1)
    {
        index = text.indexOf("\r");
    }

    if (index == -1)
    {
        index = text.indexOf("\n");
    }

    if (index != -1)
    {
        text = text.slice(0, index);
    }
    else
    {
        text = text.slice(0, 1024);
    }

    text = text.replace(/[\r\n]/g," ");

    details = new Object();

    details.url = "http://www.babylon.com/definition/" + urlencode(text) + "/" + language;
    details.method = "GET";
    details.headers = {};
    details.data = "";
    details.onload = lookupCallback;

    dictionarySelf.lookupText = text;

    dictionarySelf.xmlhttpRequest(details);
}

function handleDictionaryClick(action)
{
    var text;

    text = dictionarySelf.getViewerWindowSelectedText();

    if (text == "")
    {
        text = dictionarySelf.getSummaryWindowSelectedText();
    }

    if (text != "")
    {
        lookupDictionary(text, "English");
    }
}

gmsPlugin_dictionary.prototype.previewload = function()
{
    enabled = false;

    id = this.getCurrentValue();

    if (id != "")
    {
        enabled = true;
    }

    var added = this.registerMenuCommand("Dictionary", "Ctrl+Shift+D", "Dictionary",  "dictionary.png", "dictionary", enabled, handleDictionaryClick);

    if (added)
    {
        this.addMenuDivider();
    }
}