// Name: Mouse Gestures 2
// Description: Mouse gestures with right click
// ExternalScripts: http://jgesture.googlepages.com/jgesture-1.0.3.js
// AccessRights: ALL
// ConfigurationRequired: Yes

var gesture2Self;

function gmsPlugin_gesture2()
{
    gesture2Self = this;
}

gmsPlugin_gesture2.prototype.handleemail = function() { return true; };
gmsPlugin_gesture2.prototype.handleaddressbook = function() { return true; };
gmsPlugin_gesture2.prototype.handlecalendar = function() { return true; };
gmsPlugin_gesture2.prototype.handletasks = function() { return true; };
gmsPlugin_gesture2.prototype.handlenotes = function() { return true; };

function gesture2_handleGesture(name, moves)
{
    var udil = null;
    var action = null;
    var menu = undefined;

    if (name == "right")
    {
        if (gesture2Self.type == "EMAIL")
        {
            action = "replyall";
        }
        else
        {
            action = "open";
        }
    }
    else if (name == "top_right" || name == "topright")
    {
        action = "reply";
    }
    else if (name == "top_left" || name == "topleft")
    {
        action = "forward";
    }
    else if (name == "bottom_right" || name == "bottomright")
    {
        action = "print";
    }
    else if (name == "bottom_left" || name == "bottomleft")
    {
        action = "open";
    }
    else if (name == "left")
    {
        action = "delete";
    }
    else if (name == "bottom")
    {
        if (gesture2Self.existMenuCommand("readnext"))
        {
            action = "readnext";
        }
        else
        {
            udil = gesture2Self.getNextValue();
        }
    }
    else if (name == "top")
    {
        if (gesture2Self.existMenuCommand("readprev"))
        {
            action = "readprev";
        }
        else
        {
            udil = gesture2Self.getPreviousValue();
        }
    }
    else if (name == "rotateclockwise")
    {
        menu = "command";
        action = "compose";
    }
    else if (name == "rotatecounterclockwise")
    {
        action = "refresh";
    }

    if (udil != null && udil != "")
    {
        gesture2Self.selectValue(udil);
    }
    else if (action != null && action != "")
    {
        gesture2Self.clickMenuCommand(action, menu);
    }
}

gmsPlugin_gesture2.prototype.previewload = function()
{
    var v = this.getViewerWindow();

    if (v.gesture2SelfInit === undefined)
    {
        v.gesture2SelfInit = true;

        $("html", v.document).gesture(
            function (gs) { gesture2_handleGesture(gs.getName(), gs.moves);},
            { button: "2" }
        );

        var s = this.getSummaryWindow();

        $("html", s.document).gesture(
            function (gs) { gesture2_handleGesture(gs.getName(), gs.moves);},
            { button: "2" }
        );
    }
}

gmsPlugin_gesture2.prototype.configload = function()
{
    var html = "";

    html += "<center>Example Mouse Gesture Gizmo</center><br>";
    html += "<center>";
    html += "<table>";
    html += "<tr><td colspan=2>The following gestures are supported:</td></tr>";
    html += "<tr><td colspan=2></td></tr>";
    html += "<tr><td>Left</td><td>Delete</td></tr>";
    html += "<tr><td>Right</td><td>Reply All or Open</td></tr>";
    html += "<tr><td>Up</td><td>Previous</td></tr>";
    html += "<tr><td>Down</td><td>Next</td></tr>";
    html += "<tr><td>Up+Right</td><td>Reply</td></tr>";
    html += "<tr><td>Up+Left</td><td>Forward</td></tr>";
    html += "<tr><td>Down+Right</td><td>Print</td></tr>";
    html += "<tr><td>Down+Left</td><td>Open</td></tr>";
    html += "<tr><td>Rotate Clockwise</td><td>Compose</td></tr>";
    html += "<tr><td>Rotate Anti-Clockwise</td><td>Refresh</td></tr>";
    html += "</table>";


    this.insertCustomContent("config", html);
}