// Name: Google Translate
// Description: Translates text into your current language
// AccessRights: ALL
// ExternalScripts: http://www.google.com/jsapi

var googleTranslateSelf;

function gmsPlugin_googletranslate()
{
    googleTranslateSelf = this;

    google.load("language", "1");
}

gmsPlugin_googletranslate.prototype.handleemail = function() { return true; };
gmsPlugin_googletranslate.prototype.handleaddressbook = function() { return true; };
gmsPlugin_googletranslate.prototype.handlecalendar = function() { return true; };
gmsPlugin_googletranslate.prototype.handletasks = function() { return true; };
gmsPlugin_googletranslate.prototype.handlenotes = function() { return true; };

function translateViewerResult(result)
{
    if (result.translation)
    {
        var v = googleTranslateSelf.getViewerWindow();
        var e = v.document.getElementById("subject");

        e.innerHTML = result.translation;
    }
    else
    {
        alert("Translation Error: " + result.error.message);
    }
}

function translateSummaryResult(result)
{
    if (result.translation)
    {
        googleTranslateSelf.setSummaryWindowHTML(result.translation);
    }
    else
    {
        alert("Translation Error: " + result.error.message);
    }
}

function translatePromptResult(result)
{
    if (result.translation)
    {
        alert(result.translation);
    }
    else
    {
        alert("Translation Error: " + result.error.message);
    }
}

function getGoogleLanguage(language)
{
    var googleLanguage = "unknown";

    for (l in top.google.language.Languages)
    {
        if (top.google.language.Languages[l] == language)
        {
            googleLanguage = top.google.language.Languages[l];
            break;
        }
    }

    return googleLanguage;
}

function translate(text,isHTML,callback)
{
    var language = googleTranslateSelf.getLanguage();

    googleLanguage = getGoogleLanguage(language);

    if (googleLanguage == "unknown")
    {
        fields = language.split("-");

        googleLanguage = getGoogleLanguage(fields[0]);
    }

    if (googleLanguage == "unknown")
    {
        googleLanguage = "en";
    }

    option = new Object();

    text = text.slice(0, 512);

    option.text = text;

    if (isHTML)
    {
        option.type = "html";
    }
    else
    {
        option.type = "text";
    }

    top.google.language.translate(option, "", googleLanguage, callback);
}

function handleTranslateClick(action)
{
    var text;

    text = googleTranslateSelf.getViewerWindowSelectedText();

    if (text == "")
    {
        text = googleTranslateSelf.getSummaryWindowSelectedText();
    }

    if (text != "")
    {
        translate(text, false, translatePromptResult)
    }
    else
    {
        var v = googleTranslateSelf.getViewerWindow();
        var e = v.document.getElementById("subject");

        var viewerText = e.innerHTML;
        var summaryText = googleTranslateSelf.getSummaryWindowHTML();

        translate(viewerText, true, translateViewerResult)
        translate(summaryText, true, translateSummaryResult)
    }
}

gmsPlugin_googletranslate.prototype.previewload = function()
{
    enabled = false;

    id = this.getCurrentValue();

    if (id != "")
    {
        enabled = true;
    }

    var added = this.registerMenuCommand("Translate", "Ctrl+Shift+T", "Google Translate",  "translate.png", "translate", enabled, handleTranslateClick);

    if (added)
    {
        this.addMenuDivider();
    }
}

