// Name: Hide Buttons
// Description: All user to show or hide buttons
// AccessRights: ALL

var hideSelf;

function gmsPlugin_hide()
{
    this.state = "show";

    hideSelf = this;

    hideSelf.level = -1;
}

gmsPlugin_hide.prototype.handleemail = function() { return true; };
gmsPlugin_hide.prototype.handleaddressbook = function() { return true; };
gmsPlugin_hide.prototype.handlecalendar = function() { return true; };
gmsPlugin_hide.prototype.handletasks = function() { return true; };
gmsPlugin_hide.prototype.handlenotes = function() { return true; };

var hideButtons1 = [ "print", "refresh" ];
var hideButtons2 = [ "redirect", "resend", "folder" ];
var hideButtons3 = [ "open", "search" ];
var hideButtons4 = [ "blocksender", "reportspam", "messageismail", "messageisjunk" ];
var hideButtons5 = [ "tag", "viewsource" ];

function setButtons(action, buttons)
{
    var i;

    if (action == "hide")
    {
        for (i = 0; i < buttons.length; i++)
        {
            hideSelf.hideMenuCommand(buttons[i]);
        }
    }
    else
    {
        for (i = 0; i < buttons.length; i++)
        {
            hideSelf.showMenuCommand(buttons[i]);
        }
    }
}

function hideSaveConfiguration()
{
    hideSelf.setConfigurationValue("level", hideSelf.level);
}

function handlehideClick(action)
{
    hideSelf.state = action;

    var level = hideSelf.level;

    if (action == "hide")
    {
        level--;
    }
    else if (action == "show")
    {
        level++;
    }

    if (level >= 5)
    {
        setButtons("show", hideButtons5);
    }
    else
    {
        setButtons("hide", hideButtons5);
    }

    if (level >= 4)
    {
        setButtons("show", hideButtons4);
    }
    else
    {
        setButtons("hide", hideButtons4);
    }

    if (level >= 3)
    {
        setButtons("show", hideButtons3);
    }
    else
    {
        setButtons("hide", hideButtons3);
    }

    if (level >= 2)
    {
        setButtons("show", hideButtons2);
    }
    else
    {
        setButtons("hide", hideButtons2);
    }

    if (level >= 1)
    {
        setButtons("show", hideButtons1);
    }
    else
    {
        setButtons("hide", hideButtons1);
    }

    if (level > 0)
    {
        hideSelf.enableMenuCommand("hide");
    }
    else
    {
        hideSelf.disableMenuCommand("hide");
    }

    if (level < 5)
    {
        hideSelf.enableMenuCommand("show");
    }
    else
    {
        hideSelf.disableMenuCommand("show");
    }

    hideSelf.level = level;

    setTimeout("hideSaveConfiguration()", 250);
}

gmsPlugin_hide.prototype.init = function()
{
    this.level = this.getConfigurationValue("level", 5);
}

gmsPlugin_hide.prototype.previewload = function()
{
    var added1 = this.registerMenuCommand("", "Ctrl+Shift+P", "Show Buttons",  "plus.png",  "show", hideSelf.level < 5, handlehideClick);
    var added2 = this.registerMenuCommand("", "Ctrl+Shift+M", "Hide Buttons",  "minus.png", "hide", hideSelf.level > 0, handlehideClick);

    if (added1 || added2)
    {
        this.addMenuDivider();
    }

    handlehideClick(null);
}