// Name: RSS Reader
// Description: RSS Reader
// AccessRights: ALL
// ConfigurationRequired: Yes

var rssSelf;

function gmsPlugin_rss()
{
    rssSelf = this;
}

function loadRSSTree()
{
    var sites = rssSelf.getConfigurationValue("sites", "");

    var list = sites.split("\n");

    var site;
    var list;
    var temp;

    for (var i=0; i<list.length; i++)
    {
        site = list[i];

        temp = site.split(",");

        name = temp[0];
        url = temp[1];

        rssSelf.addTreeNodeChild(name, "rss.png", "rss." + urlencode(name) + "+" + urlencode(url), "rss", handleRSSTreeClick, "rss");
    }

    if (rssSelf.getCurrentPanel() != "rss" && rssSelf.getSelectedTreeNode() != "rss")
    {
        rssSelf.closeTreeNode("rss");
    }
}

function rssLoadFeedCallback(details)
{
    if (details.status == 200)
    {
        if (details.responseText != "")
        {
            var w = rssSelf.getContentWindow();

            ReadRSS(w.document, details.responseText, "rsstitle", "rssbody");
        }
    }
    else
    {

    }
}

function rssLoadFeed()
{
    var url = rssSelf.getFieldValue("url");

    var details = new Object();

    details.url = url;
    details.method = "GET";
    details.headers = {};
    details.data = "";
    details.onload = rssLoadFeedCallback;
    details.onerror = rssLoadFeedCallback;

    rssSelf.xmlhttpRequest(details);
}

function loadRSSFeed(name, url)
{
    var html = "";

    html += "<html>";
    html += "<head><link rel=\"stylesheet\" href=\"/webmail/plugins/rss.css\" type=\"text/css\"></head>";
    html += "<body>";
    html += "<input type=hidden id=\"url\" value=\"" + url + "\">";
    html += "<div style=\"display:none; visibility:hidden\" id=\"rsstitle\"><a href=\"(::Link::)\">(::Title::)</a><br/>(::Description::)<br/><hr noshade/></div>";
    html += "<div style=\"display:none; visibility:hidden\" id=\"rssbody\"><a href=\"(::Link::)\">(::Title::)</a>&nbsp;(::Pubdate::)<br/>(::Description::)<br/><hr noshade/><br/></div>";
    html += "</body></html>";

    rssSelf.loadCustomContent(name, html, "rssLoadFeed", false);
}

var gizmoText = "Gizmo&apos;s provide a means of adding functionality to WebMail by interfacing with external data sources. This is more commonly known as mashup technology. A mashup is a small web application that allows the combination of data from more than one source into a single integrated tool, a good example is the use of data from Google Maps to add location information to an address book entry (an example of this is included).<br><br>The current example uses Gizmo technology to retrieve and display RSS feeds published by third parties. You can subscribe to as many RSS feeds as you wish, simply by configuring them under the Gizmos &gt; RSS Reader entry in Folder or Preferences view."

function handleRSSTreeClick(id, lastId)
{
    var params = id.split(".");

    if (params.length == 1)
    {
        var html = "";

        html += "<html>";
        html += "<head><link rel=\"stylesheet\" href=\"/webmail/plugins/rss.css\" type=\"text/css\"></head>";
        html += "<body>";
        html += "<br><br><center>Example RSS Reader Gizmo</center><br>" + gizmoText;
        html += "</body></html>";

        rssSelf.loadCustomContent("RSS Reader", html, "", false);
    }
    else
    {
        var temp = id.substr(4);

        params = temp.split("+");

        var name = params[0];
        var url = params[1];

        name = urldecode(name);
        url = urldecode(url);

        name = name.replace(/^\s+|\s+$/g,"");
        url = url.replace(/^\s+|\s+$/g,"");

        loadRSSFeed(name, url);

        rssSelf.registerMenuCommand("Refresh", "Ctrl+Shift+R", "Refresh", "refresh.png", "refresh", true, handleRSSMenuClick);
        rssSelf.addMenuDivider();
    }
}

function handleRSSMenuClick(action)
{
    if (action == "refresh")
    {
        var str = rssSelf.getSelectedTreeNode();

        handleRSSTreeClick(str, "");
    }
}

gmsPlugin_rss.prototype.panelload = function()
{
    this.addPanelButton("RSS Reader", "", "rss.png", "rss");
}

gmsPlugin_rss.prototype.treeload = function()
{
    this.addTreeNodeNext("RSS Reader", "rss.png", "rss", "rss", handleRSSTreeClick);

    loadRSSTree();
}

function rssConfigButtonHandler(action)
{
    var sites = rssSelf.getFieldValue("sites");

    rssSelf.setConfigurationValue("sites", sites);

    rssSelf.reload();
}

gmsPlugin_rss.prototype.configload = function()
{
    var html = "";

    html += "<table>";
    html += "<tr><td>&nbsp;</td></tr>";
    html += "<tr><td>Enter sites one per line in the format Name,URL</td></tr>";
    html += "<tr><td><textarea rows=10 cols=70 id=\"sites\"></textarea></td></tr>";
    html += "<tr><td>&nbsp;</td></tr>";
    html += "<tr><td align=right colspan=2><span id=\"button1\"></span></td></tr>";
    html += "</table>";

    this.insertCustomContent("config", html);

    this.insertCustomButton("button1", "     OK     ", "ok", rssConfigButtonHandler);

    var sites = this.getConfigurationValue("sites", "");

    this.setFieldValue("sites", sites);
}



/*  Simple Javascript RSS Reader Version 1.0
    Copyright (c) 2006 CS Truter
    Written by Christoff Truter
    email: Christoff@cstruter.com - (Please let me know if you intend to use the script) */

/* Replace all occurances of a string
  (Parameters) totalValue:'complete string'
        oldValue:'value to be replaced' newValue:'value used for replace' */

function Replace(totalValue,oldValue,newValue)
{
    while(totalValue.indexOf(oldValue) > -1)
        totalValue=totalValue.replace(oldValue,newValue);
            return totalValue;
}

/* Get XML Node
   (Parameters) TagName:'XML Element' node:'Element row number' */

function getNode(xmlDoc, items, TagName, attr, node)
{
    var value = "";

    try
    {
        var currentNode = (node == null) ? xmlDoc.getElementsByTagName(TagName) :
                                           items[node].getElementsByTagName(TagName);

        if(currentNode.length > 0)
        {
            if (attr == '')
            {
                value =  currentNode[0].firstChild.nodeValue;
            }
            else
            {
                value =  currentNode[0].getAttribute(attr);
            }
        }
    }
    catch(e)
    {

    }

    return value;
}

/* Load XML Object
   (Parameters) rssFeed:'RSS File' Body:'Layer for RSS Body' Title:'Layer for RSS Title' */

function ReadRSS(d, rssFeedBody, Title, Body)
{
    var rssTitle = d.getElementById(Title);
    var rssBody = d.getElementById(Body);

    try
    {
        var xmlDoc;

        try //Internet Explorer
        {
            xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
            xmlDoc.async="false";
            xmlDoc.loadXML(rssFeedBody);
        }
        catch(e)
        {
            try //Firefox, Mozilla, Opera, etc.
            {
                parser=new DOMParser();
                xmlDoc=parser.parseFromString(rssFeedBody,"text/xml");
            }
            catch(e) {alert(e.message)}
        }

        var items;

        var titleTag;
        var linkTag;
        var pubDateTag;
        var descriptionTag;

        titleTag = 'title';
        linkTag = 'link';
        linkAttr = '';
        pubDateTag = 'pubDate';
        descriptionTag = 'description';

        // Try RSS
        items = xmlDoc.getElementsByTagName('item');

        if (items.length == 0)
        {
            // Try Atom
            items = xmlDoc.getElementsByTagName('entry');

            titleTag = 'title';
            linkTag = 'link';
            linkAttr = 'href';
            pubDateTag = 'published';
            descriptionTag = 'content';
        }

        SetRSSTemplates(d, xmlDoc, items, titleTag, linkTag, linkAttr, pubDateTag, descriptionTag, rssTitle, rssBody);
    }
    catch(e)
    {
        rssTitle.innerHTML = 'Error occured';
        rssBody.innerHTML = 'Thrown Error:'+e.message+"<br/>Note: "+errorHappendHere;
    }

    rssTitle.style.display = "block";
    rssTitle.style.visibility = "visible";

    rssBody.style.display = "block";
    rssBody.style.visibility = "visible";
}

/* Set HTML Template
    Did it this way to make the look and feel of the feed easy customizable, dont like mixing
    layout with code. */

function SetRSSTemplates(d, xmlDoc, items, titleTag, linkTag, linkAttr, pubDateTag, descriptionTag, rssTitle, rssBody)
{
    if (rssBody)
    {
        try
        {
            var buffer = "";

            for(var i=0; i< items.length; i++)
            {
                var output = (d.all) ? Replace(rssBody.innerHTML,"(::Link::)",getNode(xmlDoc,items,linkTag,linkAttr,i))
                                           : Replace(rssBody.innerHTML,"%28::Link::%29",getNode(xmlDoc,items,linkTag,linkAttr,i));
                output = Replace(output,"(::Title::)",getNode(xmlDoc,items,titleTag,'', i));
                output = Replace(output,"(::Pubdate::)",getNode(xmlDoc,items,pubDateTag,'',i));
                output = Replace(output,"(::Description::)",getNode(xmlDoc,items,descriptionTag,'',i));
                buffer+=output;
            }

            buffer = buffer.replace(/<a /g, "<a target=\"_blank\" ");
            buffer = buffer.replace(/<A /g, "<A target=\"_blank\" ");

            rssBody.innerHTML = buffer;
        }
        catch(e)
        {
            rssBody.innerHTML = 'Thrown Error:'+e.message+"<br/>Note: "+errorHappendHere;
        }
    }

    if (rssTitle)
    {
        try
        {
            var output = Replace(rssTitle.innerHTML,"(::Title::)",getNode(xmlDoc,items,titleTag,''));
            output = (d.all) ? Replace(output,"(::Link::)",getNode(xmlDoc,items,linkTag,linkAttr))
                                   : Replace(output,"%28::Link::%29",getNode(xmlDoc,items,linkTag,linkAttr));
            output = Replace(output,"(::Description::)",getNode(xmlDoc,items,descriptionTag,''));

            output = output.replace(/<a /g, "<a target=\"_blank\" ");
            output = output.replace(/<A /g, "<A target=\"_blank\" ");

            rssTitle.innerHTML = output;
        }
        catch(e)
        {
            rssTitle.innerHTML = 'Thrown Error:'+e.message+"<br/>Note: "+errorHappendHere;
        }
    }
}