// Name: Skype
// Description: Adds Skype Call and Chat buttons
// ExternalScripts: http://download.skype.com/share/skypebuttons/js/skypeCheck.js
// AccessRights: ALL

var skypeSelf;

function gmsPlugin_skype()
{
    skypeSelf = this;

    skypeSelf.addedButtons = false;
}

gmsPlugin_skype.prototype.handleaddressbook = function() { return true; };

function handleSkypeClick(action)
{
    var url = "";

    if (action == "skypecall" || action == "winskypecall")
    {
        var number = "";
        var w = undefined;

        if (action == "winskypecall")
        {
            w = skypeSelf.getCurrentWindow();
        }

        number = getTelephoneNumber("worktel", w);

        if (number == "")
        {
            number = getTelephoneNumber("hometel", w);
        }

        if (number != "")
        {
            url = "skype:" + number + "?call";
        }
    }
    else if (action == "skypechat" || action == "winskypechat")
    {
        var account;
        var w = undefined;

        if (action == "winskypechat")
        {
            w = skypeSelf.getCurrentWindow();
        }

        account = getSkypeAccount(w);

        if (account != "")
        {
            url = "skype:" + account + "?chat";
        }
    }

    if (url != "")
    {
        if (skypeCheck())
        {
            newwindow = window.open("/webmail/plugins/skype.mml?url=" + urlencode(url), "_blank", "height=5,width=5,top=0,left=0");

            newwindow.blur()
            window.focus()
        }
    }
}

function getTelephoneNumber(id, w)
{
    var number = "";
    var text = "";

    if (w !== undefined)
    {
        text = skypeSelf.getFieldValue(id, w);
    }
    else
    {
        text = skypeSelf.getAttributeHTML(id);
    }

    var index = text.indexOf(":");

    if (index != -1)
    {
        number = text.slice(index + 1);
    }
    else
    {
        number = text;
    }

    number = number.replace(/ /ig,"");

    if (number.charAt(0) == '0')
    {
        number = "+44" + number.slice(1);
    }
    else if (number != "" && number.charAt(0) != '+')
    {
        number = "+" + number;
    }

    return number;
}

function getSkypeAccount(w)
{
    var account = "";
    var text = "";

    if (w !== undefined)
    {
        text = skypeSelf.getFieldValue("note", w);
    }
    else
    {
        text = skypeSelf.getAttributeText("note");
    }

    text = text.toLowerCase();

    var index = text.indexOf("skype:");

    if (index != -1)
    {
        text = text.slice(index + 6);

        index = text.indexOf(" ");

        if (index == -1)
        {
            index = text.indexOf("\r");
        }

        if (index == -1)
        {
            index = text.indexOf("\n");
        }

        if (index != -1)
        {
            account = text.slice(0, index);
        }
        else
        {
            account = text;
        }
    }

    account = account.replace(/ /ig,"");

    return account;
}

gmsPlugin_skype.prototype.previewload = function()
{
    var callenabled = false;
    var chatenabled = false;

    var id = this.getCurrentValue();
    var number = "";
    var account = "";

    if (id != "")
    {
        if (number == "")
        {
            number = getTelephoneNumber("worktel");
        }

        if (number == "")
        {
            number = getTelephoneNumber("hometel");
        }

        if (account == "")
        {
            account = getSkypeAccount();
        }

        if (number != "")
        {
            callenabled = true;
        }

        if (account != "")
        {
            chatenabled = true;
        }
    }

    if (account == "")
    {
        account = "ahopefullynonexistenceskpyeaccount";
    }

    var statusurl = "http://mystatus.skype.com/smallicon/" + account;

    this.registerMenuCommand("Skype Call", "", "Skype Call", "phone.png", "skypecall", false, handleSkypeClick);
    this.registerMenuCommand("Skype Chat", "", "Skype Chat",  statusurl,  "skypechat", false, handleSkypeClick);

    if (!skypeSelf.addedButtons)
    {
        this.addMenuDivider();

        skypeSelf.addedButtons = true;
    }

    if (callenabled)
    {
        this.enableMenuCommand("skypecall");
    }
    else
    {
        this.disableMenuCommand("skypecall");
    }

    if (chatenabled)
    {
        this.enableMenuCommand("skypechat");
    }
    else
    {
        this.disableMenuCommand("skypechat");
    }
}

function skypeChangeHandler()
{
    skypeSelf.windowload();
}

gmsPlugin_skype.prototype.windowload = function()
{
    var callenabled = false;
    var chatenabled = false;

    var w = this.getCurrentWindow();

    var account = "";
    var number = "";
    var account = "";

    if (number == "")
    {
        number = getTelephoneNumber("worktel", w);
    }

    if (number == "")
    {
        number = getTelephoneNumber("hometel", w);
    }

    if (account == "")
    {
        account = getSkypeAccount(w);
    }

    if (account != "")
    {
        chatenabled = true;
    }

    if (number != "")
    {
        callenabled = true;
    }

    if (account == "")
    {
        account = "ahopefullynonexistenceskpyeaccount";
    }

    var statusurl = "http://mystatus.skype.com/smallicon/" + account;

    this.registerMenuCommand("Skype Call", "", "", "phone.png", "winskypecall", false, handleSkypeClick, "command", w);
    this.registerMenuCommand("Skype Chat", "", "",  statusurl,  "winskypechat", false, handleSkypeClick, "command", w);

    if (callenabled)
    {
        this.enableMenuCommand("winskypecall", "command", w);
    }
    else
    {
        this.disableMenuCommand("winskypecall", "command", w);
    }

    if (chatenabled)
    {
        this.enableMenuCommand("winskypechat", "command", w);
    }
    else
    {
        this.disableMenuCommand("winskypechat", "command", w);
    }

    var e;

    e = w.document.getElementById("worktel");

    if (e)
    {
        e.onkeyup = skypeChangeHandler;
    }

    e = w.document.getElementById("hometel");

    if (e)
    {
        e.onkeyup = skypeChangeHandler;
    }

    e = w.document.getElementById("note");

    if (e)
    {
        e.onkeyup = skypeChangeHandler;
    }
}
